if you are going to upgrade to 4.0.4 PL 1, there are some issues :-)